package main

import (
	"fmt"
	"math"
)

type Shape interface { // สร้างอินเตอร์เฟสที่มีเมธอดหาพื้นที่และความยาวเส้นรอบรูปร่าง
	Area() float64
	perimeter() float64
}
type Circle struct {
	radius float64
}
type Rectangle struct {
	length float64
	width  float64
}

func (c Circle) Area() float64 { // เมธอดหาพื้นที่วงกลม
	return math.Pi * math.Pow(c.radius, 2)
}
func (r Rectangle) Area() float64 { // เมธอดหาพื้นที่สี่เหลี่ยมผืนผ้า
	return r.length * r.width
}
func (c Circle) perimeter() float64 { // เมธอดหาความยาวรอบวงกลม
	return 2 * math.Pi * c.radius
}
func (r Rectangle) perimeter() float64 { // เมธอดหาความยาวรอบสี่เหลี่ยมผืนผ้า
	return 2 * (r.length + r.width)
}
func main() {
	var s Shape                                                  // ประกาศตัวแปร s ชนิด Shape ในรูปอินเทอร์เฟซ
	s = Circle{12}                                               // ปรับใช้อินเทอร์เฟซกับชุดข้อมูลของวงกลม
	fmt.Printf("Area of circle : %.2f\n", s.Area())              // คำนวณพื้นที่ของวงกลม
	fmt.Printf("Perimeter of circle : %.2f\n", s.perimeter())    // คำนวณเส้นรอบวงของวงกลม
	s = Rectangle{6, 4}                                          // ปรับใช้อินเทอร์เฟซกับชุดข้อมูลของสี่เหลี่ยมผืนผ้า
	fmt.Printf("Are of Rectangle : %.2f\n", s.Area())            // คำนวณพื้นที่ของสี่หลี่ยมผืนผ้า
	fmt.Printf("Perimeter of Rectangle : %.2f\n", s.perimeter()) //คำนวณความยาวรอบสี่เหลี่ยม
}
