package main

import "fmt"

type ProductDes interface { // สร้างอินเทอร์เฟส ProductDes
	details()
	stockValue()
}
type CustomerDes interface { // สร้างอินเทอร์เฟส CustomerDes
	details()
}
type product struct { // สร้างสตรักต์ product
	name     string
	category string
	price    int
	stock    int
}

func (d product) details() { // สร้างเมธอด details ใช้ Receiver ด้วย product
	fmt.Println("Product Name : ", d.name)
	fmt.Println("Product Category : ", d.category)
	fmt.Println("Product Price : ", d.price)
	fmt.Println("Product Stock : ", d.stock)
}
func (s product) stockValue() { // สร้างเมธอด stockValue ใช้ Receiver ด้วย product
	sv := s.price * s.stock
	fmt.Printf("%s has Stock Value : %d\n", s.name, sv)
}

type customer struct { // สร้างสตรักต์ customer
	name    string
	tel     string
	email   string
	address string
}

func (c customer) details() { // สร้างเมธอด details ใช้ Receiver ด้วย customer
	fmt.Println("Customer Name : ", c.name)
	fmt.Println("Customer Tel. : ", c.tel)
	fmt.Println("Customer Email : ", c.email)
	fmt.Println("Customer Addrss : ", c.address)
}

func main() {
	x := product{"xPad 10", "Tablet", 18000, 8} // ประกาศตัวแปร x ในรูปสตรักต์
	var pd ProductDes = x                       // ประกาศตัวแปรอินเทอร์เฟส pd เชื่อมกับสตรักต์
	pd.details()                                // ใช้อินเทอร์เฟส pd เรียกใช้เมธอด detail
	pd.stockValue()                             // ใช้อินเทอร์เฟส pd เรียกใช้เมธอด stockValue
	y := customer{"Tanong Srisiam", "0801234567", "tanong@xmail.com",
		"999 Bangna BKK 10260"} // ประกาศตัวแปร y ในรูปสตรักต์
	var ct CustomerDes = y // ประกาศตัวแปรอินเทอร์เฟส ct เชื่อมกับสตรักต์
	ct.details()           // ใช้อินเทอร์เฟส ct เรียกใช้เมธอด detail
}
