package main

import (
	"fmt"
	"math"
)

type Shape interface { // สร้างชนิดข้อมูล Shape ในรูปของอินเทอร์เฟซ
	Area() float64
}
type Circle struct { // สร้างชนิดข้อมูล Circle ในรูปของสตรักต์สำหรับวงกลม
	radius float64
}
type Rectangle struct { // สร้างชนิดข้อมูล Rectangle เป็นสตรักต์สำหรับสี่เหลี่ยมผืนผ้า
	length float64
	width  float64
}

func (c Circle) Area() float64 { // สร้างเมธอด Area() คำนวณพื้นที่วงกลม
	return math.Pi * math.Pow(c.radius, 2)
}
func (r Rectangle) Area() float64 { // สร้างเมธอด Area() คำนวณพื้นที่สี่เหลี่ยมผืนผ้า
	return r.length * r.width
}

// ฟังก์ชันการหาผลรวมพื้นที่ของวงกลมและสี่เหลี่ยมผืนผ้าขนาดต่าง ๆ
func totalArea(shapes []Shape) float64 {
	var area float64
	for _, s := range shapes {
		area += s.Area()
	}
	return area
}
func main() {
	// กำหนดขนาดของรูปสี่เหลี่ยมผืนผ้า 2 รูป
	r1 := Rectangle{length: 10, width: 5}
	r2 := Rectangle{length: 4, width: 3}
	// กำหนดขนาดของวงกลม 2 รูป
	c1 := Circle{radius: 10}
	c2 := Circle{radius: 8}

	Allcircle := []Shape{c1, c2}    // Allcircle เป็น Slices ของอินเทอร์เฟสเก็บรัศมีวงกลม
	Allrectangle := []Shape{r1, r2} // Allrectangle เป็น Slices ของอินเทอร์เฟสเก็บค่าสี่เหลี่ยม
	// Allshapes เป็น Slices ของอินเทอร์เฟสเก็บค่าคุณลักษณะของรูปร่างทั้งหมด
	Allshapes := []Shape{c1, c2, r1, r2}

	// หาผลรวมของพื้นที่วงกลมและสี่เหลี่ยมทุกรูปด้วยฟังก์ชัน totalArea
	fmt.Printf("Total Area of circle = %.2f\n", totalArea(Allcircle))
	fmt.Printf("Total Area of rectangle = %.2f\n", totalArea(Allrectangle))
	fmt.Printf("Total Area of circle and rectangle = %.2f\n", totalArea(Allshapes))
}
