package main

import "fmt"

func main() {
	sl := []int{8, 6, -3, 5, 2, -8, 10, -4, 9} //ตัวแปร sl ชนิดข้อมูล Slice เก็บเลขจำนวนเต็ม 9 ตัว

	ch := make(chan int)        // สร้างแชนเนลเป็นตัวแปร ch
	go sum(sl[:3], ch)          // สร้าง Goroutine พร้อมส่ง slice เลข 3 ตัวแรก และแชลเนล ch
	go sum(sl[3:6], ch)         // สร้าง Goroutine พร้อมส่ง slice เลข 3 ตัวถัดไป และแชลเนล ch
	go sum(sl[6:], ch)          // สร้าง Goroutine พร้อมส่ง slice เลข 3 ตัวหลัง และแชลเนล ch
	x, y, z := <-ch, <-ch, <-ch // รับค่าผลรวมจากแชนเนล ch ทั้ง 3 ชุดมายังตัวแปร x y z

	fmt.Println(x, y, z, x+y+z) // แสดงค่า x y z และหาผลรวมทั้งหมด
}

func sum(sl []int, ch chan int) { // ฟังก์ชัน sum รับค่า slice และแชนเนล ch
	sum := 0                // ประกาศตัวแปร sum ไว้เก็บผลรวม
	for _, vl := range sl { // วนลูปอ่านค่าจากสไลด์ sl แต่ละค่ามาไว้ใน vl
		sum += vl // นำค่าจาก vl มารวมกับค่าใน sum และเก็บผลรวมไว้ใน sum
	}
	ch <- sum // นำค่าผลรวมจาก sum ไปยังแชนเนล ch
}
