package main

import (
	"fmt"
	"time"
)

func main() {

	ch := make(chan int, 2)     // สร้างตัวแปรแชนเนล ch มีบัฟเฟอร์สำหรับ 2 ค่า
	go send(ch)                 // สร้าง Goroutine ของฟังก์ชัน send() พร้อมส่ง ch
	time.Sleep(2 * time.Second) // หน่วงเวลา
	for val := range ch {       // นำข้อมูลจากบัฟเฟอร์ ch ออกมาทีละค่าจนปิดแชนเนล
		fmt.Println("read  from ch : ", val) // อ่านค่าจาก ch ออกมาแสดงผล
		time.Sleep(2 * time.Second)          // หน่วงเวลา
	}
}
func send(ch chan int) { // ฟังก์ชัน send รับค่าแชนเนล
	for i := 0; i < 4; i++ { // วบลูป 4 รอบ
		ch <- i                                   // ส่งค่าประจำรอบไปยังแชนเนล
		fmt.Println("sent", i, "-> ch : success") // พิมพ์แจ้งว่าส่งค่าไปยังแชนเนลสำเร็จ
	}
	close(ch) // ปิดแชนเนล ไม่มีการส่งค่าไปยังแชนเนล
}
