package main

import (
	"fmt"
	"time"
)

func server1(ch chan string) { // ฟังก์ชัน server1 รับแชนเนล ch เป็นสตริง
	time.Sleep(3 * time.Second)  // มีการหน่วงเวลา 3 วินาที
	ch <- "receive from server1" // ส่งค่าไปยังแชนเนล ch
}
func server2(ch chan string) { // ฟังก์ชัน server2 รับแชนเนล ch เป็นสตริง
	time.Sleep(1 * time.Second)  // มีการหน่วงเวลา 1 วินาที
	ch <- "receive from server2" // ส่งค่าไปยังแชนเนล ch
}
func main() {
	c1 := make(chan string) // สร้างแชนเนล c1
	c2 := make(chan string) // สร้างแชนเนล c2
	go server1(c1)          // เรียกใช้ฟังก์ชัน server1 เป็น goroutine
	go server2(c2)          // เรียกใช้ฟังก์ชัน server2 เป็น goroutine
	select {                // ใช้ select เลือกหลายรับส่งค่า
	case msg1 := <-c1: // กรณีที่ msg1 สามารถรับค่าจาก c1
		fmt.Println(msg1) // พิมพ์
	case msg2 := <-c2: // กรณีที่ msg2 สามารถรับค่าจาก c2
		fmt.Println(msg2)
	}
}
