package main

import (
	"fmt"
	"time"
)

func server(ch chan string) { // ฟังก์ชัน server
	time.Sleep(3 * time.Second) // หน่วงเวลา 3 วินาที ให้รอนาน
	ch <- "receive from server" // ส่งข้อความไปยังแชนเนล ch
}
func main() {
	c := make(chan string) // สร้างแชนเนล c
	go server(c)           // เรียกใช้ฟังก์ชัน server เป็น goroutine
	for {                  // วนลูปรอรับข้อมูลจากแชนเนล
		time.Sleep(300 * time.Millisecond) // หน่วงเวลา 3 วินาที
		select {
		case msg := <-c: // รับข้อมูลจากแชนเนล c เก็บในตัวแปร msg
			fmt.Println(msg) // พิมพ์แสดงข้อมูลที่รับมา
			return           // ออกจากลูป for
		default: // ถ้าไม่มีการรับส่งข้อมูลใน case ใดทำงาน
			fmt.Println("no message from server") // แจ้งว่าไม่มีข้อความจากเซิร์ฟเวอร์
		}
	}
}
